import java.util.*;

public class Sample {  
  public static void main(String[] args) {
    List<Integer> numbers = List.of(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
                           
    //Java 7 and earlier:
    //imperative + object-oriented
    //
    //Java 8 and later:
    //imperative + functional +
    //	object-oriented
    //
    //
    //imperative: tell what to do and also how to do it
    //declarative: tell what to do and *not* how to do it
    //functional: declarative + higher-order functions
    
    //functions:
    //we pass object to functions
    //we create object in functions
    //we return object from functions
    
    //higher-order function
    //we pass function to functions
    //we create function in functions
    //we return function from functions
    
    //leads to functional decomposition in addition to 
    //object decomposition
    
    int result = numbers.stream()
      .filter(e -> e % 2 == 0) //function: declarative + higher-order function
      .mapToInt(e -> e * 2)    //funtional: declarative + higher-order function
      .sum();                  //declarative
    
    System.out.println(result);
  }
}