import java.util.*;

public class Sample {  
  public static void main(String[] args) {
    //filter: given a collection of numbers,
    //  Yi = filter(P(Xi))
    //where P returns true or false for given X
    //Yi exists if P(Xi) is true
    
    // 0 <= number of output <= number of input
    //elements in the output is a subset of elements in the input
    
    //map
    // yi = fn(xi)
    // fn transforms xi into yi
    
    //  number of output is the same as the number of input
    //the type of the output may be different from the type
    //of the input
    
    //filter and map - swimlane operations
    
    //reduce cuts across boundaries
    
    List<Integer> numbers = List.of(1, 2, 3, 4, 5);
    
    System.out.println(numbers.stream()
      .filter(e -> e % 2 == 0)
      .map(e -> e * 2)
      .reduce(0, (total, e) -> total + e));
      
      //  func(input, e0) -> output0
      //  func(output0, e1) -> output1
      //  func(output1, e2) -> ...
      
    /*  
          f         m         r    0
    1     |                         \
    ---------------------------------\----------------
    2               4                 0 + 4 = 4
    ------------------------------------------\-------
    3     |                                    \
    --------------------------------------------\-----
    4               8                            4 + 8 = 12
    --------------------------------------------------   \
    5     |                                               ===12
    */  
  }
}