import java.util.*;
import java.util.stream.*;

public class Sample {  
  public static void main(String[] args) {
    List<Integer> numbers = List.of(1, 2, 3);
    
    //if you have one to one function (f1)
    //then Stream<X>.map(f1) => Stream<Y>

                         
    Stream<Double> doubled = numbers.stream()
      .map(e -> e * 2.0);

    //Stream<Integer>.map(Integer -> Integer * 2.0) => Stream<Double>
    doubled.forEach(System.out::println);
    
    //if you have a one to many function (f2)
    //then Stream<X>.map(f2) => Stream<List<Y>>
                                       
    Stream<List<Integer>> beforeAndAfter = numbers.stream()
      .map(e -> List.of(e - 1, e + 1));
    
    //Stream<Integer>.map(Integer -> List<Integer>) => Stream<List<Integer>>
    beforeAndAfter.forEach(System.out::println);
    
    //But, did you want a collection of collection as result
    //or only a collection as a result?
    
    //If you wanted the latter, then you can't use map for a
    //one to many function.
    
    Stream<Integer> beforeAndAfter2 = numbers.stream()
      .flatMap(e -> List.of(e - 1, e + 1).stream());
      
    //Stream<Integer>.flatMap(Integer -> Stream<Integer>) => Stream<Integer>
    beforeAndAfter2.forEach(System.out::println);
  }
}