import java.util.*;

public class Sample {        
  public static boolean isGT3(int n) {
    System.out.println("isGT3 " + n);
    return n > 3;
  }

  public static boolean isEven(int n) {
    System.out.println("isEven " + n);
    return n % 2 == 0;
  }

  public static int doubleIt(int n) {
    System.out.println("doubleIt " + n);    
    return n * 2;
  }
  
  public static void main(String[] args) {
    List<Integer> numbers = List.of(1, 2, 3, 5, 4, 6, 7, 8, 9, 10);
    
    //find the double of the first number > 3 and is even
                                        
    //functional programming is 
    //functional composition + lazy evaluation
             
    //streams are lazy
    //streams have two kinds of methods.
    //intermediate and terminal
    //intermediate (those that return Stream) don't do any work
    //until a terminal method kicks in
    System.out.println(
      numbers.stream()
        .filter(Sample::isGT3) //1, 2, 3, 5, 4
        .filter(Sample::isEven) //5, 4
        .map(Sample::doubleIt)  //4
        .findFirst()  //comment out this and the next line and run
        .orElse(0)
        );
        
    //Stream does not run a function for each element.
    //Instead it runs an element through a collection of functions,
    //but only as necessary.
  }
}